
           org         $0
           dc.l        $1000
           dc.l        programm
           ds.l        $fe

programm:
           move.w      #$0000,d0
           move.w      #$4000,d1
           move.w      #$8000,d2
           move.w      #$c000,d3
           move.w      #$ffff,d4

; bhi (groesser)
           cmp.w       d3,d3
           bhi         fehler          ;$c000 > $c000 ?
           cmp.w       d3,d1
           bhi         fehler          ;$4000 > $c000 ?
           cmp.w       d1,d3
           bhi         bhi_ok          ;$c000 > $4000 ?
           bra         fehler
bhi_ok:

; bls (kleiner/gleich)
           cmp.w       d1,d3
           bls         fehler          ;$c000 <= $4000 ?
           cmp.w       d3,d3
           bls         bls_ok1         ;$c000 <= $c000 ?
           bra         fehler
bls_ok1:
           cmp.w       d3,d1
           bls         bls_ok2         ;$4000 <= $c000 ?
           bra         fehler
bls_ok2:

; bcc (carry-clear)
           move.w      d4,d7
           addq.w      #1,d7
           bcc         fehler          ;$ffff + 1 ?
           move.w      d2,d7
           addq.w      #1,d7
           bcc         bcc_ok          ;$8000 + 1 ?
           bra         fehler
bcc_ok:

; bcs (carry-set)
           move.w      d2,d7
           addq.w      #1,d7
           bcs.s       fehler          ;$8000 + 1 ?
           move.w      d4,d7
           addq.w      #1,d7
           bcs.s       bcs_ok          ;$ffff + 1 ?
           bra.s       fehler
bcs_ok:

; bne (ungleich)
           cmp.w       d2,d2
           bne.s       fehler          ;$8000 <> $8000 ?
           cmp.w       d3,d2
           bne.s       bne_ok          ;$c000 <> $8000 ?
           bra.s       fehler
bne_ok:

; beq (gleich)
           cmp.w       d2,d3
           beq.s       fehler          ;$8000 <> $c000 ?
           cmp.w       d2,d2
           beq.s       beq_ok          ;$8000 == $8000 ?
           bra.s       fehler
beq_ok:

; bvc (overflow-clear)
           cmp.w       d1,d2
           bvc.s       fehler          ;$8000 - $4000 ?
           cmp.w       d3,d3
           bvc.s       bvc_ok
           bra.s       fehler
bvc_ok:

; bvs (overflow-set)
           cmp.w       d3,d3
           bvs.s       fehler
           cmp.w       d1,d2
           bvs.s       bvs_ok          ;$8000 - $4000 ?
           bra.s       fehler
bvs_ok:

; bmi (minus)
           cmp.w       d3,d3
           bmi.s       fehler
           cmp.w       d2,d1
           bmi.s       bmi_ok          ;$4000 - $8000 ?
           bra.s       fehler
bmi_ok:

; bpl (plus)
           cmp.w       d2,d1
           bpl.s       fehler          ;$8000 - $4000 ?
           cmp.w       d3,d3
           bpl.s       bpl_ok
           bra.s       fehler
bpl_ok:

; blt (less-than)
           cmp.w       d2,d1
           blt.s       fehler          ;$4000 - $8000 ?
           cmp.w       d1,d2
           blt.s       blt_ok          ;$8000 - $4000 ?
           bra.s       fehler
blt_ok:

; bgt (greater-than)
           cmp.w       d1,d2
           bgt.s       fehler          ;$8000 - $4000 ?
           cmp.w       d2,d1
           bgt.s       bgt_ok          ;$4000 - $8000 ?
           bra.s       fehler
bgt_ok:

; ble (less-than)
           cmp.w       d2,d1
           ble.s       fehler          ;$4000 - $8000 ?
           cmp.w       d1,d2
           ble.s       ble_ok1         ;$8000 - $4000 ?
           bra.s       fehler
ble_ok1:
           cmp.w       d3,d3
           ble.s       ble_ok2
           bra.s       fehler
ble_ok2:

; bge (greater-than)
           cmp.w       d1,d2
           bge.s       fehler          ;$8000 - $4000 ?
           cmp.w       d2,d1
           bge.s       bge_ok1         ;$4000 - $8000 ?
           bra.s       fehler
bge_ok1:
           cmp.w       d3,d3
           bge.s       bge_ok2
           bra.s       fehler
bge_ok2:


ok:        bsr         test

fehler:    bra.s       fehler

           org         $0588
test:      bra.s       test